package test;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import jp.co.hos.coreports.IRecordSet;
import jp.co.hos.coreports.events.IEventListener;
import jp.co.hos.coreports.exception.CrException;

/**
 * f[^CSVt@CǂݍރR[hZbgłB
 * ̃NX͍Œ̋@\ꂽTvp̃NXłB
 *
 */
public class SimpleCSVRecordSet implements IRecordSet {
    String [] headers;
    
    BufferedReader reader = null;    
    Map record = new HashMap();
    
    /**
     * t@Cw肵SimpleCSVRecordSet\z܂B
     * @param fileName CSVt@C
     */
    public SimpleCSVRecordSet(String fileName) {
        try {
            FileReader fr = new FileReader(fileName);
            reader = new BufferedReader(fr);
            
            headers = readLine();        
        } catch (FileNotFoundException fnfex) {
            fnfex.printStackTrace();
        } 
    }
    
    /**
     * Psǂݍ݁AJ𕪊Ď擾܂B
     * @return J̔z
     */
    private String [] readLine() {        
        try {
            String line = reader.readLine();
            return line.split(",");
        } catch (NullPointerException npex) {
            return null;
        } catch (IOException ioex) {
            return null;
        }
    }
    
    /**
     * [_܂B
     *
     */
    private void close() {
        if (reader != null) {
            try {
                reader.close();                            
            } catch (IOException ioex) {
                ioex.printStackTrace();
            }
        }
    }
    
    /*
     * @see java.lang.Object#finalize()
     */
    protected void finalize() throws Throwable {
        close();
        super.finalize();
    }

    /*
     * @see jp.co.hos.coreports.IRecordSet#addEventListener(jp.co.hos.coreports.events.IEventListener)
     */
    public void addEventListener(IEventListener listener) throws CrException {

    }

    /*
     * @see jp.co.hos.coreports.IRecordSet#getValue(java.lang.Object)
     */
    public Object getValue(Object key) throws CrException {
        return record.get(key);
    }

    /*
     * @see jp.co.hos.coreports.IRecordSet#getValue(int)
     */
    public Object getValue(int index) throws CrException {
        return record.get(headers[index]);
    }

    /*
     * @see jp.co.hos.coreports.IRecordSet#next()
     */
    public boolean next() throws CrException {
        String [] values = readLine();
        if (values == null) {
            close();
            return false;
        }
        
        record.clear();
        for (int i = 0; i < headers.length; i++) {
            record.put(headers[i], values[i]);
        }
        
        return true;
    }

}
